您的位置:首页 > 其它

[Leetcode] 724. Find Pivot Index 解题报告

2018-02-17 10:44 260 查看
题目

Given an array of integers 
nums
, write a method that returns the "pivot" index of this
array.

We define the pivot index as the index where the sum of the numbers to the left of the index is equal to the sum of the numbers to the right of the index.

If no such index exists, we should return -1. If there are multiple pivot indexes, you should return the left-most pivot index.

Example 1:

Input:
nums = [1, 7, 3, 6, 5, 6]
Output: 3
Explanation:
The sum of the numbers to the left of index 3 (nums[3] = 6) is equal to the sum of numbers to the right of index 3.
Also, 3 is the first index where this occurs.


Example 2:
Input:
nums = [1, 2, 3]
Output: -1
Explanation:
There is no index that satisfies the conditions in the problem statement.


Note:

The length of 
nums
 will be in the range 
[0,
10000]
.
Each element 
nums[i]
 will be an integer in the range 
[-1000,
1000]
.
思路

原来想成二分查找了,后来发现想复杂了,并且思路也不对,因为nums中的数有可能是负数,所以sums不是单调的。后来发现我们只需要首先计算出整个数组的和,然后遍历一遍数组就可以了。对于每个元素,我们可以在O(1)的时间复杂度内计算出其左边元素的和和右边元素之和,一旦发现相等,就返回该索引。

算法的时间复杂度是O(n),空间复杂度是O(1)。一定是最优解了。

代码

class Solution {
public:
int pivotIndex(vector<int>& nums) {
int size = nums.size();
if (size == 0) {
return -1;
}
int sum = 0;
for (int i = 0; i < size; ++i) {
sum += nums[i];
}
int left_sum = 0, right_sum = sum;
for (int i = 0; i < size; ++i) {
right_sum -= nums[i];
if (left_sum == right_sum) {
return i;
}
left_sum += nums[i];
}
return -1;
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: